#ifndef EXTRAND_H_INCLUDED
#define EXTRAND_H_INCLUDED

#ifndef RANDOM_STRENGTH
#warning "RANDOM_STRENGTH defaulting to 0"
#define RANDOM_STRENGTH 0
#endif /*RANDOM_STRENGTH*/

#define EXTRAND_VERSION_MAJOR 1
#define EXTRAND_VERSION_MINOR 3

typedef unsigned long __RANDOM_BUFFER_004;
unsigned long __rand_004(void);
unsigned long __random_004(unsigned long);
unsigned long __random_normal_004(unsigned long, unsigned long);
void __randomize_004(void);
void __srand_004(unsigned long);
void __load_rand_state_004(__RANDOM_BUFFER_004 *);
void __save_rand_state_004(__RANDOM_BUFFER_004 *);

typedef struct
{
	unsigned long state[7];
	char location;
} __RANDOM_BUFFER_028;
unsigned long __rand_028(void);
unsigned long __random_028(unsigned long);
unsigned long __random_normal_028(unsigned long, unsigned long);
void __randomize_028(void);
void __srand_028(unsigned long);
void __load_rand_state_028(__RANDOM_BUFFER_028 *);
void __save_rand_state_028(__RANDOM_BUFFER_028 *);

typedef struct
{
	unsigned long state[15];
	char location;
} __RANDOM_BUFFER_060;
unsigned long __rand_060(void);
unsigned long __random_060(unsigned long);
unsigned long __random_normal_060(unsigned long, unsigned long);
void __randomize_060(void);
void __srand_060(unsigned long);
void __load_rand_state_060(__RANDOM_BUFFER_060 *);
void __save_rand_state_060(__RANDOM_BUFFER_060 *);

typedef struct
{
	unsigned long state[31];
	char location;
} __RANDOM_BUFFER_124;
unsigned long __rand_124(void);
unsigned long __random_124(unsigned long);
unsigned long __random_normal_124(unsigned long, unsigned long);
void __randomize_124(void);
void __srand_124(unsigned long);
void __load_rand_state_124(__RANDOM_BUFFER_124 *);
void __save_rand_state_124(__RANDOM_BUFFER_124 *);

typedef struct
{
	unsigned long state[63];
	char location;
} __RANDOM_BUFFER_252;
unsigned long __rand_252(void);
unsigned long __random_252(unsigned long);
unsigned long __random_normal_252(unsigned long, unsigned long);
void __randomize_252(void);
void __srand_252(unsigned long);
void __load_rand_state_252(__RANDOM_BUFFER_252 *);
void __save_rand_state_252(__RANDOM_BUFFER_252 *);

#define RAND_MAX_LONG 4294967295

#if RANDOM_STRENGTH == 0

#if 0
unsigned long __rand_state_004 = 1;
#endif

#define rand_long() __rand_004()
#define random_long(x) __random_004(x)
#define random_normal(x, y) __random_normal_004(x, y)
#define randomize_long() __randomize_004()
#define srand_long(x) __srand_004(x)
#define LoadRandState(x) __load_rand_state_004(x)
#define SaveRandState(x) __save_rand_state_004(x)
#define RANDOM_BUFFER __RANDOM_BUFFER_004

#elif RANDOM_STRENGTH == 1

extern unsigned long __rand_state_028[7];
extern unsigned char __rear_028;
extern unsigned char __front_028;

#define rand_long() __rand_028()
#define random_long(x) __random_028(x)
#define random_normal(x, y) __random_normal_028(x, y)
#define randomize_long() __randomize_028()
#define srand_long(x) __srand_028(x)
#define LoadRandState(x) __load_rand_state_028(x)
#define SaveRandState(x) __save_rand_state_028(x)
#define RANDOM_BUFFER __RANDOM_BUFFER_028

#elif RANDOM_STRENGTH == 2

extern unsigned long __rand_state_060[15];
extern unsigned char __rear_060;
extern unsigned char __front_060;

#define rand_long() __rand_060()
#define random_long(x) __random_060(x)
#define random_normal(x, y) __random_normal_060(x, y)
#define randomize_long() __randomize_060()
#define srand_long(x) __srand_060(x)
#define LoadRandState(x) __load_rand_state_060(x)
#define SaveRandState(x) __save_rand_state_060(x)
#define RANDOM_BUFFER __RANDOM_BUFFER_060

#elif RANDOM_STRENGTH == 3

extern unsigned long __rand_state_124;
extern unsigned char __rear_124;
extern unsigned char __front_124;

#define rand_long() __rand_124()
#define random_long(x) __random_124(x)
#define random_normal(x, y) __random_normal_124(x, y)
#define randomize_long() __randomize_124()
#define srand_long(x) __srand_124(x)
#define LoadRandState(x) __load_rand_state_124(x)
#define SaveRandState(x) __save_rand_state_124(x)
#define RANDOM_BUFFER __RANDOM_BUFFER_124

#else

extern unsigned long __rand_state_252[63];
extern unsigned char __rear_252;
extern unsigned char __front_252;

#define rand_long() __rand_252()
#define random_long(x) __random_252(x)
#define random_normal(x, y) __random_normal_252(x, y)
#define randomize_long() __randomize_252()
#define srand_long(x) __srand_252(x)
#define LoadRandState(x) __load_rand_state_252(x)
#define SaveRandState(x) __save_rand_state_252(x)
#define RANDOM_BUFFER __RANDOM_BUFFER_252

#endif /*RANDOM_STRENGTH*/

#endif /*EXTRAND_H_INCLUDED*/
