#include "extrand_int.h"

void __srand_252(unsigned long seed)
{
	unsigned short i;

	/*these first two bits just fill the state array using the LCRNG*/
	__rand_state_252[0] = seed * 0x41C64E6D + 0x3039;

	for(i = 1; i < 63; i++)
	{
		__rand_state_252[i] = __rand_state_252[i - 1] * 0x41C64E6D + 0x3039;
	}

	__rear_252 = 0;
	__front_252 = 1;

	/*this bit cycles through the state array 10 times to make sure the random numbers are
	really random*/
	for(i = 0; i < 630; i++)
	{
		__rand_252();
	}
}
